package main

import (
	"GtDataStore/common/middleware"
	"flag"
	"fmt"

	"GtDataStore/app/cmd/dtgateway/internal/config"
	"GtDataStore/app/cmd/dtgateway/internal/handler"
	"GtDataStore/app/cmd/dtgateway/internal/svc"

	"github.com/zeromicro/go-zero/core/conf"
	"github.com/zeromicro/go-zero/rest"
)

var configFile = flag.String("f", "etc/dtgateway.yaml", "the config file")

func main() {
	flag.Parse()

	var c config.Config
	conf.MustLoad(*configFile, &c)

	server := rest.MustNewServer(c.RestConf)
	defer server.Stop()

	ipWhiteList := []string{"127.0.0.1/32", "47.96.12.136/32", "120.55.44.4/32", "58.214.245.78/32"}
	server.Use(middleware.WhiteListCheck(ipWhiteList))

	ctx := svc.NewServiceContext(c)
	handler.RegisterHandlers(server, ctx)

	fmt.Printf("Starting server at %s:%d...\n", c.Host, c.Port)
	server.Start()
}
