// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcItemConfigFieldNames          = builder.RawFieldNames(&DcItemConfig{})
	dcItemConfigRows                = strings.Join(dcItemConfigFieldNames, ",")
	dcItemConfigRowsExpectAutoSet   = strings.Join(stringx.Remove(dcItemConfigFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcItemConfigRowsWithPlaceHolder = strings.Join(stringx.Remove(dcItemConfigFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcItemConfigModel interface {
		Insert(ctx context.Context, data *DcItemConfig) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcItemConfig, error)
		Update(ctx context.Context, data *DcItemConfig) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcItemConfigModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcItemConfig struct {
		Id                 int64     `db:"id"`
		ProjectId          int64     `db:"project_id"`
		DeviceCode         string    `db:"device_code"`           // 位号
		ItemName           string    `db:"item_name"`             // 点位名
		ItemAlias          string    `db:"item_alias"`            // 别名
		MinVal             float64   `db:"min_val"`               // 量程最小值
		MaxVal             float64   `db:"max_val"`               // 量程最大值
		ItemOneValue       int64     `db:"item_one_value"`        // 约定值1
		ItemOneValueColor  string    `db:"item_one_value_color"`  // 约定值 1 颜色
		ItemZeroValue      int64     `db:"item_zero_value"`       // 约定值 0
		ItemZeroValueColor string    `db:"item_zero_value_color"` // 约定值 0 颜色
		IsFlicker          int64     `db:"is_flicker"`            // 是否闪烁 0 不闪烁 1 闪烁
		BitValue           string    `db:"bit_value"`             // 石景山取bit位规则
		CreateTime         time.Time `db:"create_time"`
	}
)

func newDcItemConfigModel(conn sqlx.SqlConn) *defaultDcItemConfigModel {
	return &defaultDcItemConfigModel{
		conn:  conn,
		table: "`dc_item_config`",
	}
}

func (m *defaultDcItemConfigModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcItemConfigModel) FindOne(ctx context.Context, id int64) (*DcItemConfig, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcItemConfigRows, m.table)
	var resp DcItemConfig
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcItemConfigModel) Insert(ctx context.Context, data *DcItemConfig) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcItemConfigRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.ItemName, data.ItemAlias, data.MinVal, data.MaxVal, data.ItemOneValue, data.ItemOneValueColor, data.ItemZeroValue, data.ItemZeroValueColor, data.IsFlicker, data.BitValue)
	return ret, err
}

func (m *defaultDcItemConfigModel) Update(ctx context.Context, data *DcItemConfig) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcItemConfigRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.ItemName, data.ItemAlias, data.MinVal, data.MaxVal, data.ItemOneValue, data.ItemOneValueColor, data.ItemZeroValue, data.ItemZeroValueColor, data.IsFlicker, data.BitValue, data.Id)
	return err
}

func (m *defaultDcItemConfigModel) tableName() string {
	return m.table
}
