// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"

	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcItemHistoryDataFieldNames          = builder.RawFieldNames(&DcItemHistoryData{})
	dcItemHistoryDataRows                = strings.Join(dcItemHistoryDataFieldNames, ",")
	dcItemHistoryDataRowsExpectAutoSet   = strings.Join(stringx.Remove(dcItemHistoryDataFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcItemHistoryDataRowsWithPlaceHolder = strings.Join(stringx.Remove(dcItemHistoryDataFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcItemHistoryDataModel interface {
		//Insert(ctx context.Context, data *DcItemHistoryData) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcItemHistoryData, error)
		//Update(ctx context.Context, data *DcItemHistoryData) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcItemHistoryDataModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcItemHistoryData struct {
		//Id        int64     `db:"id"`
		ProjectId int64     `db:"project_id"` // 项目ID
		ItemName  string    `db:"item_name"`  // 点位名
		Val       float64   `db:"val"`        // 值
		HTime     time.Time `db:"h_time"`     // 采集数据时间
		//CTime     time.Time `db:"c_time"`     // 创建时间
	}
)

func newDcItemHistoryDataModel(conn sqlx.SqlConn) *defaultDcItemHistoryDataModel {
	return &defaultDcItemHistoryDataModel{
		conn:  conn,
		table: "`dc_item_history_data`",
	}
}

func (m *defaultDcItemHistoryDataModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcItemHistoryDataModel) FindOne(ctx context.Context, id int64) (*DcItemHistoryData, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcItemHistoryDataRows, m.table)
	var resp DcItemHistoryData
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

//func (m *defaultDcItemHistoryDataModel) Insert(ctx context.Context, data *DcItemHistoryData) (sql.Result, error) {
//	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?)", m.table, dcItemHistoryDataRowsExpectAutoSet)
//	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.ItemName, data.Val, data.HTime, data.CTime)
//	return ret, err
//}

//func (m *defaultDcItemHistoryDataModel) Update(ctx context.Context, data *DcItemHistoryData) error {
//	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcItemHistoryDataRowsWithPlaceHolder)
//	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.ItemName, data.Val, data.HTime, data.CTime, data.Id)
//	return err
//}

func (m *defaultDcItemHistoryDataModel) tableName() string {
	return m.table
}
